
#include <deal.II/grid/tria.h>
#include <deal.II/grid/tria_iterator.h>
#include <deal.II/grid/tria_accessor.h>
#include <deal.II/grid/grid_generator.h>
#include <deal.II/grid/grid_in.h>
#include <deal.II/grid/grid_out.h>
#include <deal.II/grid/tria_boundary_lib.h>
#include <deal.II/numerics/data_out.h>
#include <deal.II/numerics/vector_tools.h>

#include <iostream>
#include <fstream>

using namespace dealii;

int main ()
{
  Triangulation<3> tria;
  
  std::ifstream in;
  in.open("box.unv");

  GridIn<3,3> gi;
  gi.attach_triangulation(tria);
  gi.read_unv(in);
  
  Triangulation<3>::active_cell_iterator cell = tria.begin_active();
  Triangulation<3>::active_cell_iterator endc = tria.end();    
  for (; cell!=endc; ++cell) {    
    std::cout << "cell: " << cell->id() << "\n";
    std::cout << "  material_id: " << cell->material_id()  << "\n";
    for (unsigned int f=0; f<GeometryInfo<3>::faces_per_cell; ++f) {
      if (cell->face(f)->at_boundary())
        std::cout << "    boundary_id: " << cell->face(f)->boundary_id() << "\n";
    }    
  }   
  in.close();
  return 0;
}
